/* 4- Haga una Implementacin optimizada del algoritmo de ordenamiento por burbujeo. La ejecucin puede terminar en forma temprana si, en una pasada, se detecta que el arreglo est ordenado.*/
/* Solucin en lenguaje C */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define N 10

/* Prototipo */
void ordenar(int datos[], int n);

/* Programa Principal */
int main()
{
	int datos[N];
	int i;

	/* Inicializacin del generador de nmeros aleatorios */
	srand ( time(NULL) );

	printf("Arreglo original: ");
	for (i=0; i<N; i++)
	{
		datos[i] = rand() % 100; /* Entre 0 y 99 */
		printf("%d ", datos[i]);
	}
	printf("\n");

	/* Ordenamiento */
	ordenar(datos, N);

	printf("Arreglo ordenado: ");
	for (i=0; i<N; i++)
		printf("%d ", datos[i]);
	printf("\n");

	return 0;
}
void ordenar(int datos[], int n)
{

	enum {FALSO, VERDADERO} ordenado;
	int i, j, aux, it = 0;

	ordenado = FALSO;
	for (i = n-1; i>0 && !ordenado; i--)
	{

		ordenado = VERDADERO;
		for (j = 1; j <= i; j++)
		{
			if (datos[j-1] > datos[j])
			{
				/* Intercambio */
				aux = datos[j];
				datos[j] = datos[j-1];
				datos[j-1] = aux;
				ordenado = FALSO;
			}
			it ++; /* Contador de iteraciones */
		}
	}
	printf("Cantidad de iteraciones: %d\n", it);
}