{3- Desarrolle un ordenamiento por seleccin (en forma ascendente) de un arreglo de caracteres. Luego contabilice la ocurrencia de cada carcter en una sola pasada.}
{Solucin en lenguaje Pascal}

PROGRAM alg_03_cap05;

CONST N = 10;

{ El arreglo de datos debe pasarse por referencia: VAR }
PROCEDURE ordenar(VAR datos: STRING[N]; n: INTEGER);

VAR 	i, j: INTEGER;
	aux: CHAR;

BEGIN
	FOR i:=1 TO n-1 DO
		FOR j:=i+1 TO n DO
			IF (datos[i] > datos[j]) THEN
				BEGIN
					{ Intercambio }
					aux := datos[j];
					datos[j] := datos[i];
					datos[i] := aux;
				END
END;

PROCEDURE estadisticas(datos: STRING[N]; n: INTEGER);

VAR 	i, count: INTEGER;
	car: CHAR;

BEGIN
	car := datos[1];
	count := 0;
	FOR i:=1 TO n DO
		BEGIN
			IF (datos[i] = car) THEN
				count := count + 1
			ELSE
				BEGIN
					WRITELN('El carcter "', car, '" aparece ', count, ' veces');
					car := datos[i];
					count := 1;
				END;
		END;
	WRITELN('El carcter "', car, '" aparece ', count, ' veces');
END;

VAR 	caracteres: STRING[N];
	i: INTEGER;

{ Programa Principal }
BEGIN

	{ Se usa una cadena, pero se la trata como un arreglo }
	caracteres := 'HOLA MUNDO';

	WRITE('Arreglo original: ');
	FOR i:=1 TO N DO
		WRITE(caracteres[i], ' ');
	WRITELN;

	{ Ordenamiento }
	ordenar(caracteres, N);

	WRITE('Arreglo ordenado: ');
	FOR i:=1 TO N DO
		WRITE(caracteres[i], ' ');
	WRITELN;
	WRITELN;

	{ Estadsticas }
	estadisticas(caracteres, N);
END.