{4- Haga una Implementacin optimizada del algoritmo de ordenamiento por burbujeo. La ejecucin puede terminar en forma temprana si, en una pasada, se detecta que el arreglo est ordenado.}
{Solucin en lenguaje Pascal}

PROGRAM alg_04_cap05;
CONST N = 10;

type t_arreglo = ARRAY[1..10] OF INTEGER;

{ El arreglo de datos debe pasarse por referencia: VAR }
PROCEDURE ordenar(VAR datos: t_arreglo; n: INTEGER);

VAR	 i, j, aux, it: INTEGER;
	ordenado: BOOLEAN;

BEGIN
	ordenado := FALSE;
	i := n;
	it := 0;

	WHILE ( (i >= 2) AND (NOT ordenado) ) DO
		BEGIN
			ordenado := TRUE;
			j := 2;
			WHILE (j <= i) DO
				BEGIN
					IF (datos[j-1] > datos[j]) THEN
						BEGIN
							{ Intercambio }
							aux := datos[j];
							datos[j] := datos[j-1];
							datos[j-1] := aux;
							ordenado := FALSE;
						END;
					it := it + 1;
					j := j + 1;
				END;
			i := i - 1;
			END;

		WRITELN('Cantidad de iteraciones: ', it);
		END;

VAR datos: t_arreglo;
	i: INTEGER;

{ Programa Principal }
BEGIN

	{ Inicializacin del generador de nmeros aleatorios }
	RANDOMIZE;

	WRITE('Arreglo original: ');
	FOR i:=1 TO N DO
		BEGIN
			datos[i] := RANDOM(100); { Entre 0 y 99 }
			WRITE(datos[i], ' ');
		END;
	WRITELN;

	{ Ordenamiento }
	ordenar(datos, N);

	WRITE('Arreglo ordenado: ');
	FOR i:=1 TO N DO
		WRITE(datos[i], ' ');
END.